#
# USAGE: awk -f auto_photo.awk x=[x_sext] y=[y_sext] star=[num] count=1 [file01(catalog[apphot])] count=2 [file02(sext)] 
#
BEGIN{
       i1=1;
       i2=1;
     }

     {
       if(count==1)
         {
           if( substr($1,1,1) != "#" )
             {
               if(star==$2)
                 {
                   dx=$3-x;
                   dy=$4-y;
                   print("STAR_NO.="star" dx="dx" dy="dy); 
                   star=-999;
                 }
               NAME11[i1]=$1;
               NAME12[i1]=$2;
               X1[i1]    =$3;
               Y1[i1]    =$4;
               MAG1[i1]  =$9;
               #print(NAME11[i1]" "NAME12[i1]" "X1[i1]" "Y1[i1]" "MAG1[i1])
               ++i1;
               i1_max = i1;
             }
         }
       else if(count==2)
         { 
           if( substr($1,1,1) != "#" )
             {
               NAME2[i2]=$1;
               X2[i2]   =$11+dx;
               Y2[i2]   =$12+dy;
               MAG2[i2] =$6;
               ++i2;
               i2_max = i2;
             }
         }                    

     }

END{ 
     
# First Check     
     
      ERR1=0; ERR2=0; mag_limit=16.0; nsig=1.0 
      for(i=1; i<i1_max; ++i)
        {
          for(j=1; j<i2_max; ++j)
            {
              if( (X1[i]-X2[j])*(X1[i]-X2[j])+(Y1[i]-Y2[j])*(Y1[i]-Y2[j]) < 16 )
                {
                  print(NAME11[i]" "NAME12[i]" "X1[i]" "X2[j]" "Y1[i]" "Y2[j]" "MAG1[i]" "MAG2[j]" "MAG1[i]-MAG2[j]);
                      ERR1=ERR1+(MAG1[i]-MAG2[j]);
                      ERR2=ERR2+(MAG1[i]-MAG2[j])*(MAG1[i]-MAG2[j]);
                }
            }
        } 

      AVG1= ERR1/(i1_max-1);
      ERR2= ERR2/(i1_max-1);
      DEV1= ERR2 - AVG1*AVG1;
      SIG1= sqrt(DEV1);

      print("Data="i1_max-1" AVG="AVG1" SIG="SIG1" : All Data");

# Twice check

      ERR3=0; ERR4=0; i3_max=0;   
      for(i=1; i<i1_max; ++i)
        {
          for(j=1; j<i2_max; ++j)
            {
              if( (X1[i]-X2[j])*(X1[i]-X2[j])+(Y1[i]-Y2[j])*(Y1[i]-Y2[j]) < 16 )
                {
#                 print(NAME11[i]" "NAME12[i]" "X1[i]" "X2[j]" "Y1[i]" "Y2[j]" "MAG1[i]" "MAG2[j]" "MAG1[i]-MAG2[j]);
                  if( MAG1[i] < mag_limit && (MAG1[i]-MAG2[j]) < AVG1+nsig*SIG1 && (MAG1[i]-MAG2[j]) > AVG1-nsig*SIG1 )
                    {
                      ERR3=ERR3+(MAG1[i]-MAG2[j]);
                      ERR4=ERR4+(MAG1[i]-MAG2[j])*(MAG1[i]-MAG2[j]);
                      ++i3_max;
                    }
                }
            }
        }    

      AVG2= ERR3/i3_max;
      ERR4= ERR4/i3_max;
      DEV2= ERR4 - AVG2*AVG2;
      SIG2= sqrt(DEV2);

      print("Data="i3_max" AVG="AVG2" SIG="SIG2" : Brighter than "mag_limit" mag : "nsig" sigma clipping");

# Third Check

      ERR5=0; ERR6=0; i4_max=0;
      for(i=1; i<i1_max; ++i)
        {
          for(j=1; j<i2_max; ++j)
            {
              if( (X1[i]-X2[j])*(X1[i]-X2[j])+(Y1[i]-Y2[j])*(Y1[i]-Y2[j]) < 16 )
                {
#                 print(NAME11[i]" "NAME12[i]" "X1[i]" "X2[j]" "Y1[i]" "Y2[j]" "MAG1[i]" "MAG2[j]" "MAG1[i]-MAG2[j]);
                  if( MAG1[i] < mag_limit && (MAG1[i]-MAG2[j]) < AVG2+nsig*SIG2 && (MAG1[i]-MAG2[j]) > AVG2-nsig*SIG2 )
                    {
                      ERR5=ERR5+(MAG1[i]-MAG2[j]);
                      ERR6=ERR6+(MAG1[i]-MAG2[j])*(MAG1[i]-MAG2[j]);
                      ++i4_max;
                    }
                }
            }
        }

      AVG3= ERR5/i4_max;
      ERR6= ERR6/i4_max;
      DEV3= ERR6 - AVG3*AVG3;
      SIG3= sqrt(DEV3);

      print("Data="i4_max" AVG="AVG3" SIG="SIG3" : Brighter than "mag_limit" mag : "nsig" sigma clipping");

# Fourth Check

      ERR7=0; ERR8=0; i5_max=0; nsig=0.90
      for(i=1; i<i1_max; ++i)
        {
          for(j=1; j<i2_max; ++j)
            {
              if( (X1[i]-X2[j])*(X1[i]-X2[j])+(Y1[i]-Y2[j])*(Y1[i]-Y2[j]) < 16 )
                {
#                 print(NAME11[i]" "NAME12[i]" "X1[i]" "X2[j]" "Y1[i]" "Y2[j]" "MAG1[i]" "MAG2[j]" "MAG1[i]-MAG2[j]);
                  if( MAG1[i] < mag_limit && (MAG1[i]-MAG2[j]) < AVG3+nsig*SIG3 && (MAG1[i]-MAG2[j]) > AVG3-nsig*SIG3 )
                    {
                      ERR7=ERR7+(MAG1[i]-MAG2[j]);
                      ERR8=ERR8+(MAG1[i]-MAG2[j])*(MAG1[i]-MAG2[j]);
                      ++i5_max;
                    }
                }
            }
        }

      AVG4= ERR7/i5_max;
      ERR8= ERR8/i5_max;
      DEV4= ERR8 - AVG4*AVG4;
      SIG4= sqrt(DEV4);

      print("Data="i5_max" AVG="AVG4" SIG="SIG4" : Brighter than "mag_limit" mag : "nsig" sigma clipping");
 
   }
